#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <irman.h>

int main (int argc, char **argv)
{
  int irfd = 0;
  unsigned char *code = NULL;
  unsigned char *oldcode = NULL;
  char *text;

  setlinebuf(stdout);
  printf("# connecting to irman...\n");
  irfd = ir_init("/dev/ttyS0");
  if (irfd >= 0) {
    printf("# connected to irman\n");
  } else {
    fprintf(stderr, "# error connecting to irman\n");
    return 1;
  }

  for (;;) {
    code = ir_get_code();
    if (code) {
      oldcode = code;
      text = ir_code_to_text(code);
      printf("code %s\n", text);
    } else {
      if (errno == IR_EDUPCODE) {
        printf("code %s dup\n", ir_code_to_text(oldcode));
      } else {
        fprintf(stderr, "# error: %s\n", ir_strerror(errno));
        ir_finish();
        exit(1);
      }
      errno = 0;
    }
  }

  return 0;
}
