package EBoxItem;

use strict;
use Qt;
use Qt::isa qw(Qt::ListBoxItem);
use Qt::attributes qw(pData);
use Data::Dumper;

my %pixmap;

sub NEW {
    my $class = shift;

    my $h = {};
    $h->{'indent'} = shift;
    $h->{'type'} = shift;
    $h->{'text'} = shift;
    $h->{'file'} = shift;

    load_images() unless %pixmap;

    $class->SUPER::NEW(@_);
    pData = $h;
}

sub load_images
{
    foreach my $file (qw(diropen dirclosed playlist song)) {
	my $filename = "$file.png";
	$pixmap{$file} = Qt::Pixmap($filename);
    }
}

sub filename { pData->{'file'} }
sub type { pData->{'type'} }


# for list item:
sub width { 700 }
sub height { 36 }
sub paint
{
    my $p = shift;  # QPainter
    my $attr = pData;
    
    my $x = $attr->{'indent'} * 30;
    my $r = Qt::Rect($x, 0, 36, 36);
    $p->drawPixmap($r, $pixmap{$attr->{'type'}});
    
    $r = Qt::Rect($x + 36, 0, 700 - ($x + 36), 36);
    $p->setFont(Qt::Font("Helvetica", 20, &Qt::Font::Bold));
    $p->drawText($r, &Qt::AlignLeft | &Qt::AlignVCenter, $attr->{'text'});
}


1;
