#!/usr/bin/perl -w


use strict;
use Qt;
use Enty;
use Socket;

# half of us goes to setup a network daemon, the other
# half starts the UI
my $pid = fork;

unless ($pid) {
    my $bindhost = shift @ARGV;
    my $port = shift @ARGV;

    $bindhost ||= "0.0.0.0";
    $port ||= 9034;
    
    my $proto = getprotobyname('tcp');
    socket(FH, PF_INET, SOCK_STREAM, $proto) || die $!;
    
    my $localaddr = inet_aton($bindhost);
    my $sin = sockaddr_in($port, $localaddr);
    setsockopt (FH,SOL_SOCKET,SO_REUSEADDR,1) or
	die "setsockopt() failed: $!\n";
    bind (FH, $sin) || die $!;
    listen(FH, 10);
    
    print STDERR "Waiting for connection...\n";
    accept(CL, FH) || die $!;
    print STDERR "Got connection.  Starting codes.\n";
    
    select(CL);
    $| = 1;
    
    open (C, "./codes |") or die "Can't open\n";
    while (<C>) {
	print CL $_;
    }
    close C;
    print STDERR "Connection gone.\n";
    close CL;
    exit 0;
}

sleep 1;  # wait for daemon to be running.

my $a = Qt::Application(\@ARGV);

my $enty = Enty;
$a->setMainWidget($enty);
Qt::Application::setOverrideCursor(Qt::Cursor(&Qt::Cursor::BlankCursor), 1);

$enty->show;
exit $a->exec;
